## @file
# ESA (C) 2000-2018 
#
# This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
#
#    SAS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    SAS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
# Param Global Variables definition for intruments

package GVParam;


sub new {
	my %params = ();
	my $class = shift;
	my $self = {};
	bless $self, $class;
	return $self;
	
}

sub setParam {
	
	my ( $self, $paramName, $paramValue ) = @_;
	$params{$paramName} = $paramValue;
	#while (($key, $value) = each(%params)){
    # print "For.. ".$key."=".$value."\n";
	#}
    $self->{_params} = $params if defined($params);
    
    return $self->{_params};
}
	
sub getParam {
	my( $self ) = @_;
	return %params;
}

sub clean()
{
	%params = ();
}

sub print {
	my( $self ) = @_;
	
	#print Param Values
	printf("Param: %s \n", $self->_params);
}

1;
