## @file
# ESA (C) 2000-2018 
#
# This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
#
#    SAS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    SAS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
# Task Global Variables definition for intruments
use XML::LibXML;

package GVTask;

sub new {
	
	my $class = shift;
	my $self = {};
	bless $self, $class;
	return $self;
	
}

sub setTask {
	my ( $self, $taskName ) = @_;
    $self->{_taskName} = $taskName if defined($taskName);
    return $self->{_taskName};
}

sub getTask {
	my( $self ) =@_;
	return $self->{_taskName};
}

sub setInfo {
	my ( $self, $taskInfo ) = @_;
    $self->{_taskInfo} = $taskInfo if defined($taskInfo);
    return $self->{_taskInfo};
}

sub getInfo {
	my( $self ) =@_;
	return $self->{_taskInfo};
}


sub setParam {
	
    my ( $self, $params ) = @_;    
    
    $self->{_params} = $params if defined($params);
    return $self->{_params};
}

sub getParams {
	my( $self ) = @_;
	return $self->{_params};
}


sub getParam {
	
	 my ( $self, $param ) = @_;
	 $params = $self->getParams();
	 return $params->{$param};
}



sub setParamValue()
{
	my ( $self, $param, $value ) = @_;
	$params = $self->getParams();		
	$params->{$param} = $value if defined($value); ; 
	
}


sub getParamValue()
{
	my ( $self, $value ) = @_;

	return $self->{$value} ; 
	
}

sub print()
{
	my ($self) = @_;
	
	printf ("Task: %s \(%s\)\n",$self->getTask(),$self->getInfo());
	$params = $self->getParams();
   	while (($key, $value) = each(%$params)){
	    printf ("PARAM: %s=%s\n",$key,$value);
	}
}

1;
