## @file
# ESA (C) 2000-2018 
#
# This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
#
#    SAS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    SAS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
# Initialize analysis parameters

#========================================================================
sub pse_parameters_init(){

#.. Read Script Options  
    my $line="@ARGV"; 
    my @save;
    my $source_name; my $source_obsID; my $source_ra; my $source_dec;
    if ( @save = grep /^\-p/ , @ARGV) {
       &pse_usage();
    };

    if ( @save = grep /^-d/ , @ARGV) {
#	     system("sasdialog $name");
#		 my $x = $? >> 8;
#    	 exit($x);
		$logger->info( "Option not yet implemented.");      
    }


#.. Default parameters (Start)
    
#.. Get the file name
	my $file = "";
    if ( @save = grep /^paramfile=/ , @ARGV) {
      $file  ="$save[-1]";
      $file  =~ s/^.*=//; 
    }else { &error_code(101); }
	
    if ( @save = grep /^outputfile=/ , @ARGV) {
      $outputfile  ="$save[-1]";
      $outputfile  =~ s/^.*=//; 
    }else { $outputfile="default"; }

	
    return($file);
}
1;
